#version 330

uniform sampler2DRect inputTex;
uniform sampler2DRect inputTex1;
uniform float transitionProgress=1.0;
uniform float transitionProgressLinear=1.0;
uniform float transitionAlpha=1.0;
uniform int transitionState;
uniform float baseAlpha=1.0;
uniform sampler2DRect maskTex;
in vec2 fsMaskTexture;


in vec2 fsTexture;
in vec2 fsTexture2;
in vec2 fsTextureSize;
in vec2 fsDirection;
in vec2 fsFragScale;
in float fsMix;

out vec4 outColor;

uniform ivec2 squares=ivec2(10,10);
uniform float smoothness=1.0;

const vec2 center = vec2(0.5, 0.5);

void main()
{
	vec2 p = gl_FragCoord.xy*fsFragScale; //fsTexture/fsTextureSize;
	vec2 v = fsDirection;
	if (v != vec2(0.0))
		v /= abs(v.x)+abs(v.y);
	float d = v.x * center.x + v.y * center.y;
	float offset = smoothness;
	float pr = smoothstep(-offset, 0.0, v.x * p.x + v.y * p.y - (d-0.5+fsMix*(1.+offset)));
	vec2 squarep = fract(p*vec2(squares));
	vec2 squaremin = vec2(pr/2.0);
	vec2 squaremax = vec2(1.0 - pr/2.0);
	float a = all(lessThan(squaremin, squarep)) && all(lessThan(squarep, squaremax)) ? 1.0 : 0.0;
	vec4 texelA=texture(inputTex,fsTexture);
	vec4 texelB=texture(inputTex1,fsTexture2);
	outColor=mix(texelB,texelA,a);
#ifdef USE_MASK
	outColor.a*=texture(maskTex,fsMaskTexture).a;
#endif
}
